// certmanDlg.cpp : implementation file
//

#include "stdafx.h"
#include "certman.h"
#include "certmanDlg.h"

#include <wincrypt.h>

#pragma comment(lib, "crypt32.lib")

#define MAXSTRLEN 256
/* The number of root certificates that are standard in Pocket PC 2003's cert store */
#define NRCERTS 11

/* Display an error message in a message box */
void _err(const wchar_t* fcn, DWORD err = GetLastError()) 
{
	wchar_t szErrMsg[MAXSTRLEN]=L"";
	wchar_t szMsg[512]=L"";
	if ( FormatMessage( FORMAT_MESSAGE_FROM_SYSTEM, 0, err, 0, szErrMsg, sizeof szErrMsg / sizeof *szErrMsg, 0 ) )
	{
		 swprintf( szMsg, L"%s failed: %s", fcn, szErrMsg );
	} else 
	{
		swprintf( szMsg, L"%s failed: 0x%08X", fcn, err );
	}
	AfxMessageBox(szMsg, MB_ICONSTOP);
}

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CCertmanDlg dialog

CCertmanDlg::CCertmanDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CCertmanDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CCertmanDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CCertmanDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CCertmanDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CCertmanDlg, CDialog)
	//{{AFX_MSG_MAP(CCertmanDlg)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CCertmanDlg message handlers

BOOL CCertmanDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	CenterWindow(GetDesktopWindow());	// center to the hpc screen

	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}



void CCertmanDlg::OnButton1() 
{
	wchar_t name[MAXSTRLEN] = L"";
	wchar_t szMsg[MAXSTRLEN] = L"";

	HCERTSTORE rootStore = 0;
	HCERTSTORE CAStore = 0;
	HCERTSTORE CAStoreUsr = 0;
	HCERTSTORE thisCertStore = 0;
	PCCERT_CONTEXT pctx = 0;
	BOOL bSuccess = FALSE;
	BYTE ComputedHash[20];
	DWORD ComputedHashSize=20;
	BOOL bCertFound = FALSE;
	int nChoice = 0;
	int i=0, j=0;

	/* SHA-1 hash fingerprints of the "trusted" root certificates 
	   in Pocket PC 2003 */
	BYTE hashbuf[NRCERTS][20]=
	{
		/* Class 2 Public Primary Certification Authority */
		{0x67, 0x82, 0xAA, 0xE0, 0xED, 0xEE, 0xE2, 0x1A, 0x58, \
		0x39, 0xD3, 0xC0, 0xCD, 0x14, 0x68, 0x0A, 0x4F, 0x60, 0x14, 0x2A},

		/* Class 3 Public Primary Certification Authority */
		{0x74, 0x2C, 0x31, 0x92, 0xE6, 0x07, 0xE4, 0x24, 0xEB, \
		0x45, 0x49, 0x54, 0x2B, 0xE1, 0xBB, 0xC5, 0x3E, 0x61, 0x74, 0xE2},

		/* Entrust.net Certification Authority (2048) */
		{0x80, 0x1D, 0x62, 0xD0, 0x7B, 0x44, 0x9D, 0x5C, 0x5C, \
		0x03, 0x5C, 0x98, 0xEA, 0x61, 0xFA, 0x44, 0x3C, 0x2A, 0x58, 0xFE},

		/* Entrust.net Secure Server Certification Authority */
		{0x99, 0xA6, 0x9B, 0xE6, 0x1A, 0xFE, 0x88, 0x6B, 0x4D, \
		0x2B, 0x82, 0x00, 0x7C, 0xB8, 0x54, 0xFC, 0x31, 0x7E, 0x15, 0x39},

		/* Equifax Secure Certificate Authority */
		{0xD2, 0x32, 0x09, 0xAD, 0x23, 0xD3, 0x14, 0x23, 0x21, \
		0x74, 0xE4, 0x0D, 0x7F, 0x9D, 0x62, 0x13, 0x97, 0x86, 0x63, 0x3A},

		/* GlobalSign Root CA */
		{0x2F, 0x17, 0x3F, 0x7D, 0xE9, 0x96, 0x67, 0xAF, 0xA5, \
		0x7A, 0xF8, 0x0A, 0xA2, 0xD1, 0xB1, 0x2F, 0xAC, 0x83, 0x03, 0x38},

		/* GTE CyberTrust Global Root */
		{0x97, 0x81, 0x79, 0x50, 0xD8, 0x1C, 0x96, 0x70, 0xCC, \
		0x34, 0xD8, 0x09, 0xCF, 0x79, 0x44, 0x31, 0x36, 0x7E, 0xF4, 0x74},

		/* GTE CyberTrust Root */
		{0x90, 0xDE, 0xDE, 0x9E, 0x4C, 0x4E, 0x9F, 0x6F, 0xD8, \
		0x86, 0x17, 0x57, 0x9D, 0xD3, 0x91, 0xBC, 0x65, 0xA6, 0x89, 0x64},

		/* Secure Server Certification Authority
		RSA Data Security, Inc. */
		{0x44, 0x63, 0xC5, 0x31, 0xD7, 0xCC, 0xC1, 0x00, 0x67, \
		0x94, 0x61, 0x2B, 0xB6, 0x56, 0xD3, 0xBF, 0x82, 0x57, 0x84, 0x6F},

		/* Thawte Premium Server CA */
		{0x62, 0x7F, 0x8D, 0x78, 0x27, 0x65, 0x63, 0x99, 0xD2, \
		0x7D, 0x7F, 0x90, 0x44, 0xC9, 0xFE, 0xB3, 0xF3, 0x3E, 0xFA, 0x9A},

		/* Thawte Server CA */
		{0x23, 0xE5, 0x94, 0x94, 0x51, 0x95, 0xF2, 0x41, 0x48, \
		0x03, 0xB4, 0xD5, 0x64, 0xD2, 0xA3, 0xA3, 0xF5, 0xD8, 0x8B, 0x8C}
	};

//#define EMULATOR 1
#ifdef EMULATOR
	HANDLE hfile = INVALID_HANDLE_VALUE;
	void* CAcert = NULL;
	HANDLE hsection = 0;
	DWORD CAcertfilesize = 0;
#endif


	rootStore = CertOpenStore(	CERT_STORE_PROV_SYSTEM, 
								0, 
								0, 
								CERT_SYSTEM_STORE_LOCAL_MACHINE, 
								L"Root");

	if (!rootStore ) 
	{
		_err(L"CertOpenStore Root (locked? Smartphone?)");
		goto cleanup;
	}

	CAStore = CertOpenStore(	CERT_STORE_PROV_SYSTEM, 
								0, 
								0, 
								CERT_SYSTEM_STORE_LOCAL_MACHINE, 
								L"CA");

	if (!CAStore )
	{
		_err(L"CertOpenStore CA (locked? Smartphone?)");
		goto cleanup;
	}

	CAStoreUsr = CertOpenStore(	CERT_STORE_PROV_SYSTEM, 
								0, 
								0, 
								CERT_SYSTEM_STORE_CURRENT_USER, 
								L"CA");

	if (!CAStoreUsr )
	{
		_err(L"CertOpenStore CA CURRENT_USER (locked? Smartphone?)");
		goto cleanup;
	}

#ifdef EMULATOR
	hfile = CreateFileForMapping (L"\\Storage Card\\cacrt.cer",   // Open selected PKCS#12 file
                     GENERIC_READ,           // Open for reading
                     FILE_SHARE_READ,        // Share for reading
                     NULL,                   // No security
                     OPEN_EXISTING,          // Existing file only
                     FILE_ATTRIBUTE_NORMAL,  // Normal file
                     NULL);                  // No template file

	if (hfile == INVALID_HANDLE_VALUE) 
	{
		_err(L"CreateFileForMapping");
		goto cleanup;
	}

	hsection = CreateFileMapping(	hfile, 
									0, 
									PAGE_READONLY, 
									0, 
									0, 
									0);
	if (!hsection) 
	{
		_err(L"CreateFileMapping");
		goto cleanup;
	}

	CAcert = MapViewOfFile(	hsection, 
							FILE_MAP_READ, 
							0, 
							0, 
							0);
	if (!CAcert) 
	{
		_err(L"MapViewOfFile");
		goto cleanup;
	}
	CAcertfilesize = GetFileSize(hfile, NULL);
	if (CAcertfilesize < 0)
	{
		_err(L"GetFileSize");
		goto cleanup;
	}

	/* Create a MSCAPI cert context from this DER encoded cert */
	pctx = CertCreateCertificateContext(	X509_ASN_ENCODING,
											(BYTE*)CAcert,
											(DWORD)CAcertfilesize);

	if (!pctx)
	{
			_err(L"CertCreateCertificateContext");
		goto cleanup;

	}
	if(!CertAddCertificateContextToStore(	rootStore,
											pctx,
											CERT_STORE_ADD_REPLACE_EXISTING,
											NULL))
	{
		_err(L"CertAddCertificateContextToStore");
		goto cleanup;
	}
	if (pctx)
	{
		CertFreeCertificateContext(pctx);
		pctx = 0;
	}
#endif


#ifdef EMULATOR
	hfile = CreateFileForMapping (L"\\Storage Card\\cacert.cer",   // Open selected PKCS#12 file
                     GENERIC_READ,           // Open for reading
                     FILE_SHARE_READ,        // Share for reading
                     NULL,                   // No security
                     OPEN_EXISTING,          // Existing file only
                     FILE_ATTRIBUTE_NORMAL,  // Normal file
                     NULL);                  // No template file

	if (hfile == INVALID_HANDLE_VALUE) 
	{
		_err(L"CreateFileForMapping");
		goto cleanup;
	}

	hsection = CreateFileMapping(	hfile, 
									0, 
									PAGE_READONLY, 
									0, 
									0, 
									0);
	if (!hsection) 
	{
		_err(L"CreateFileMapping");
		goto cleanup;
	}

	CAcert = MapViewOfFile(	hsection, 
							FILE_MAP_READ, 
							0, 
							0, 
							0);
	if (!CAcert) 
	{
		_err(L"MapViewOfFile");
		goto cleanup;
	}
	CAcertfilesize = GetFileSize(hfile, NULL);
	if (CAcertfilesize < 0)
	{
		_err(L"GetFileSize");
		goto cleanup;
	}

	/* Create a MSCAPI cert context from this DER encoded cert */
	pctx = CertCreateCertificateContext(	X509_ASN_ENCODING,
											(BYTE*)CAcert,
											(DWORD)CAcertfilesize);

	if (!pctx)
	{
			_err(L"CertCreateCertificateContext");
		goto cleanup;

	}

	if(!CertAddCertificateContextToStore(	rootStore,
											pctx,
											CERT_STORE_ADD_REPLACE_EXISTING,
											NULL))
	{
		_err(L"CertAddCertificateContextToStore");
		goto cleanup;
	}
	if (pctx)
	{
		CertFreeCertificateContext(pctx);
		pctx = 0;
	}
#endif

	/* Find user imported root certificates in LOCAL_MACHINE */
	while (pctx = CertEnumCertificatesInStore(rootStore, pctx))
	{
		/* We loop through all certs in the store */
		if (CertGetNameString(pctx, CERT_NAME_FRIENDLY_DISPLAY_TYPE, 0, 0, name, sizeof name / sizeof *name)) 
		{

			/* Get the SHA-1 hash of this cert */
			bSuccess = CertGetCertificateContextProperty(pctx, CERT_SHA1_HASH_PROP_ID,
				&ComputedHash, &ComputedHashSize);
			if (!bSuccess) 
			{
				_err(L"CertGetCertificateContextProperty (hash)");
				goto cleanup;

			}
			/* Check if the hash of this cert is the same as one of
			the standard root certificates */
			bCertFound = FALSE;
			for (i=0; i<NRCERTS; i++)
			{
				BOOL hashfound = TRUE;
				for (j=0; j<20; j++)
				{
					if (ComputedHash[j] != hashbuf[i][j])
					{
						hashfound = FALSE;
						break;
					}
				}
				if (hashfound)
				{
					bCertFound = TRUE;
					break;
				}
			}
			if (!bCertFound) {
				swprintf( szMsg, L"Found root certificate: %s\n" \
					L"Do you want to permanently delete it?", name);
				nChoice = AfxMessageBox(szMsg, MB_YESNOCANCEL | MB_ICONQUESTION );
				if (nChoice == IDCANCEL)
				{
					goto cleanup;
				}
				if (nChoice == IDYES)
				{
					if (!CertDeleteCertificateFromStore(pctx))
					{
						_err(L"CertDeleteCertificateFromStore");
						goto cleanup;
						// XXX Do we have to exit?
					}
					pctx = 0;  /* Start all over */
				}
			}
		} else 
		{
			_err(L"CertGetNameString");
			// XXX Do we have to exit?
		}
	}

	/* Find user imported intermediate certificates in LOCAL_MACHINE */
	while (pctx = CertEnumCertificatesInStore(CAStore, pctx))
	{
		/* The standard root store is empty so we don't need to 
		   check the SHA-1 fingerprint. Any cert found must have been
		   imported by the user. */
		if (CertGetNameString(pctx, CERT_NAME_FRIENDLY_DISPLAY_TYPE, 0, 0, name, sizeof name / sizeof *name)) 
		{
			//wprintf(L"Found a certificate in the CAcert file: %s\n", name);

			swprintf( szMsg, L"Found intermediate certificate: %s\n" \
					L"Do you want to permanently delete it?", name);
				nChoice = AfxMessageBox(szMsg, MB_YESNOCANCEL | MB_ICONQUESTION );
				if (nChoice == IDCANCEL)
				{
					goto cleanup;
				}
				if (nChoice == IDYES)
				{
					if (!CertDeleteCertificateFromStore(pctx))
					{
						_err(L"CertDeleteCertificateFromStore");
						goto cleanup;
						// XXX Do we have to exit?
					}
					pctx = 0; /* Start all over */
				}
		} else 
		{
			_err(L"CertGetNameString");
			// XXX Do we have to exit?
		}
	}

	/* Find user imported intermediate certificates in CURRENT_USER */
/*
	while (pctx = CertEnumCertificatesInStore(CAStoreUsr, pctx))
	{
		if (CertGetNameString(pctx, CERT_NAME_FRIENDLY_DISPLAY_TYPE, 0, 0, name, sizeof name / sizeof *name)) 
		{
			//wprintf(L"Found a certificate in the CAcert file: %s\n", name);

			swprintf( szMsg, L"Found intermediate certificate (CURRENT_USER): %s\n" \
					L"Do you want to permanently delete it?", name);
				nChoice = AfxMessageBox(szMsg, MB_YESNOCANCEL | MB_ICONQUESTION );
				if (nChoice == IDCANCEL)
				{
					goto cleanup;
				}
				if (nChoice == IDYES)
				{
					if (!CertDeleteCertificateFromStore(pctx))
					{
						_err(L"CertDeleteCertificateFromStore");
						goto cleanup;
						// XXX Do we have to exit?
					}
				}
		} else 
		{
			_err(L"CertGetNameString");
			// XXX Do we have to exit?
		}
	}
*/

	AfxMessageBox(L"No (more) user imported root certificates found.", MB_ICONINFORMATION);

cleanup:
#ifdef EMULATOR
	if (CAcert) 
	{
		UnmapViewOfFile(CAcert);
	}
	if (hsection) 
	{
		CloseHandle(hsection);
	}
	if (hfile != INVALID_HANDLE_VALUE) 
	{
		CloseHandle(hfile);
	}
#endif
	if (pctx)
	{
		CertFreeCertificateContext(pctx);
	}
	if (rootStore) 
	{
		CertCloseStore(rootStore, 0);
	}
	if (CAStore) 
	{
		CertCloseStore(CAStore, 0);
	}
	if (CAStoreUsr) 
	{
		CertCloseStore(CAStoreUsr, 0);
	}

}
